; Copyright (C) 2007 Jean-Michel Richer
	global func_xmm
	global func_xmm_unroll4

section .text


; void func_xmm(TYPE *vA, TYPE *vB, TYPE *vc, int len)
; where TYPE = unsigned char
;
func_xmm:
	push	ebp
	mov	ebp,esp
	push	esi
	push	edi
	push	ebx
	push 	ecx
	push	edx

	mov	ecx,[ebp+20]; len
	shr	ecx,4
	mov	eax, ecx
	mov	esi,[ebp+8]  ; vA
	mov	edi,[ebp+12] ; vB
	mov	ebx,[ebp+16] ; vC

	test	ecx,ecx
	jz 	end1
loop1:
	movdqu	xmm0,[esi]
	add	esi,16
	movdqu	xmm1,[edi]
	add	edi,16
	pand	xmm0, xmm1
	movdqu	[ebx], xmm0
	add	ebx,16
	dec	ecx
	jnz	loop1
end1:	
	mov	ecx,[ebp+20]
	shr	ecx,4
	shl	ecx,4
	mov	esi,[ebp+8]  ; vA
	mov	edi,[ebp+12] ; vB
	mov	ebx,[ebp+16] ; vC
loop2:
	cmp 	ecx, [ebp+20]
	jge	end2
	mov	al, [esi+ecx]
	mov	ah, [edi+ecx]
	and 	al,ah
	mov	[ebx+ecx], al
	inc	ecx
	jmp	loop2
end2:
	pop	edx
	pop	ecx
	pop	ebx
	pop	edi
	pop	esi
	mov	esp,ebp
	pop	ebp
	ret

; void func_xmm_unroll4(TYPE *vA, TYPE *vB, TYPE *vc, int len)
; where TYPE = unsigned char
;
func_xmm_unroll4:
	push	ebp
	mov	ebp,esp	
	push	esi
	push	edi
	push	ebx
	push 	ecx
	push	edx

	mov	ecx,[ebp+20]; len
	shr	ecx,6
	mov	eax, ecx

	mov	esi,[ebp+8]  ; vA
	mov	edi,[ebp+12] ; vB
	mov	ebx,[ebp+16] ; vC	
unroll4_loop1:
	test	ecx,ecx
	jz 	end
	movdqu	xmm0,[esi]
	movdqu	xmm5,[edi+16]
	movdqu	xmm1,[esi+16]
	movdqu	xmm6,[edi+32]
	movdqu	xmm2,[esi+32]
	movdqu	xmm4,[edi]
	movdqu	xmm3,[esi+48]
	movdqu	xmm7,[edi+48]
	add esi,64
	add	edi,64
	pand	xmm0,xmm4
	pand	xmm1,xmm5
	movdqu	[ebx],xmm0
	movdqu	[ebx+16],xmm1	
	pand	xmm2,xmm6
	pand	xmm3,xmm7
	movdqu	[ebx+32],xmm2	
	movdqu	[ebx+48],xmm3	
	add	ebx,64
	dec	ecx
	jnz	unroll4_loop1
end:
	pop	edx
	pop	ecx
	pop	ebx
	pop	edi
	pop	esi
	mov	esp,ebp
	pop	ebp
	ret